// MainDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CodeWarHost_1.h"
#include "MainDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainDlg dialog

CMainDlg::CMainDlg(CWnd* pParent /*=NULL*/, int w, int h)
	: CDialog(CMainDlg::IDD, pParent), arena(w, h), server_socket(arena)
{
	//{{AFX_DATA_INIT(CMainDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMainDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMainDlg)
	DDX_Control(pDX, IDC_START_WAR, m_start_war);
	DDX_Control(pDX, IDC_EDIT, m_edit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMainDlg, CDialog)
	//{{AFX_MSG_MAP(CMainDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START_WAR, OnStartWar)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainDlg message handlers

BOOL CMainDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
    arena.randomize_walls();	
    if(!server_socket.Create(codewar::connection_port)){
        MessageBox("Cannot create server socket.", "Error", MB_OK | MB_ICONERROR);
        DWORD err = GetLastError();
        std::cout<<"Cannot create server socket ("<<err<<") "<<__FILE__<<": "<<__LINE__<<std::endl;
        PostQuitMessage(-1);
    }
    std::cout<<"Server socket created."<<std::endl;
    if(!server_socket.Listen()){
        MessageBox("Cannot listen on server socket", "Error", MB_OK | MB_ICONERROR);
        DWORD err = GetLastError();
        std::cout<<"Cannot listen on server socket ("<<err<<") "<<__FILE__<<": "<<__LINE__<<std::endl;
        PostQuitMessage(-1);
    }
    std::cout<<"Server socket: listening on port "<<codewar::connection_port<<std::endl;
    Display("Server socket: listening.");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMainDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMainDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMainDlg::Display(const CString &s)
{
    m_edit.ReplaceSel(s);
    m_edit.ReplaceSel("\x0d\x0a");
}

void CMainDlg::OnStartWar() 
{
    server_socket.state = CServerSocket::war;
    server_socket.RandomizeCreatureLocations();
    server_socket.SendFeedbackToClients();
    m_start_war.EnableWindow(FALSE);
    Display("War startes");
}

void CMainDlg::PostNcDestroy() 
{
    server_socket.Close();
    std::cout<<"Server socket closed."<<std::endl;
	CDialog::PostNcDestroy();
}
