// basic_arena.cpp: implementation of the basic_arena class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CodeWarHost_1.h"
#include "basic_arena.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
basic_arena::basic_arena(int h, int w)
{
    cells.resize(h);
    for(int i=0; i<h; ++i){
        cells[i].resize(w);
    }
    for(i=0; i<h; ++i){
        for(int j=0; j<w; ++j){
            if(i==0 || j==0 || i==h-1 || j==w-1){
                cells[i][j].contents = codewar::cell_wall;
            }
        }
    }
}

basic_arena::~basic_arena()
{

}

void basic_arena::dump()
{
    std::cout<<"Arena dump:"<<std::endl;
    for(int i=0; i<cells.size(); ++i){
        for(int j=0; j<cells[0].size(); ++j){
            switch(cells[i][j].contents){
            case codewar::cell_wall:
                std::cout<<'W';
                break;
            case codewar::cell_life:
                std::cout<<'L';
                break;
            case codewar::cell_food:
                std::cout<<'F';
                break;
            case codewar::cell_empty:
                std::cout<<' ';
                break;
            }
        }
        std::cout<<std::endl;
    }
    std::cout<<std::endl;
}

void basic_arena::randomize_walls()
{
    std::cout<<"basic_arena::randomize_walls() not implemented. "<<__FILE__<<": "<<__LINE__<<std::endl;
}


namespace{
    static // VC+ workspace bug
        int DX[4][8] = {-2, -1,  0,  1,  2, -1,  2,  1,
                        -2, -2, -2, -2, -2, -1, -1, -1, 
                         2, +1,  0, -1, -2,  1,  0, -1,
                         2,  2,  2,  2,  2,  1,  1,  1};
    static
        int DY[4][8] = { 2,  2,  2,  2,  2,  1,  1,  1,
                         2,  1,  0, -1, -2,  1,  0, -1,
                        -2, -2, -2, -2, -2, -1, -1, -1, 
                        2,  1,  0, -1, -2,  1,  0, -1};
}

basic_cell & basic_arena::get_relative_cell(int x, int y, short facing, int index)
{
    static basic_cell void_cell(codewar::cell_void, -1, -1);
    int dx = DX[facing][index], dy = DY[facing][index];
    if(x+dx<0 || x+dx>=cells.size() || y+dy<0 || y+dy>=cells[0].size()){
        return void_cell;
    }
    return cells[x+dx][y+dy];
}
